program AutoUpdate;

uses
  HttpProt,
  Classes,
  Dialogs,
  SysUtils,
  IniFiles,
  StrUtils,
  Forms,
  Unit1 in 'Unit1.pas' {Form1};

var
  AffSiNon           : Boolean;
  IniDeKi, IniLangue : TIniFile;
  cl                 : THttpCli;
  Data               : TMemoryStream;
  Version, v         : String;
  i                  : integer;

{$R *.res}

begin
  Application.Initialize;
  Application.Title := 'DeKiBulle AutoUpdate';

  AffSiNon  := ParamCount = 0;
  IniDeKi   := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'dekibulle.ini');
  IniLangue := TIniFile.Create(ExtractFilePath(Application.Exename) + 'lang\' + IniDeKi.ReadString('DATA', 'Langue', 'lang-en.ini'));
  Version   := IniDeKi.ReadString('DATA', 'Version', '1.0');

  Data             := TMemoryStream.Create;
  cl               := THttpCli.Create(nil);
  cl.MultiThreaded := True;
  cl.URL           := 'http://dekibulle.free.fr/version.php';
  cl.RcvdStream    := Data;

  with IniDeKi do begin
    if ReadBool('PROXY', 'Activate', False) then begin
      cl.ProxyUsername := ReadString('PROXY', 'USER', '');
      cl.ProxyPassword := '';
      v := ReadString('PROXY', 'PASS', '');
      v := ReverseString(v);
      For i := 1 to Trunc(Length(v) / 2) do
        cl.ProxyPassword := cl.ProxyPassword + Chr(StrToIntDef('$'+Copy(v, i * 2 - 1, 2), 63)); // 63 = '?'
      cl.Proxy         := ReadString('PROXY', 'ADDRESS', '');
      cl.ProxyPort     := ReadString('PROXY', 'PORT', '');
    end;
    free;
  end;

  try
    cl.Get;
    v := Copy(StrPas(Data.Memory), 1, Data.Size);
    DecimalSeparator := '.';
    if (((Version[5] <> 'b') and (StrToFloat(v) > StrToFloat(Version)) or ((Version[5] = 'b') and (StrToFloat(v) >= StrToFloat(LeftStr(Version, 4)))))) then begin
      Application.CreateForm(TForm1, Form1);
      Form1.Label1.Caption := IniLangue.ReadString('MESSAGES', '16', 'Nouvelle version disponible');
      Form1.BtnClose.Caption := IniLangue.ReadString('ID3TAG', 'BtnClose', 'Fermer');
      Form1.Memo.Text := 'Local version:' + Version + ' - Latest version :' + v;
      Form1.BtnUpdate.Enabled := True;
    end else begin
      if AffSiNon then begin
        Application.CreateForm(TForm1, Form1);
        Form1.Label1.Caption := IniLangue.ReadString('MESSAGES', '18', 'Dernire version');  
        Form1.BtnClose.Caption := IniLangue.ReadString('ID3TAG', 'BtnClose', 'Fermer');
        Form1.Memo.Text := 'Local version:' + Version + ' - Latest version :' + v;
        Form1.BtnUpdate.Enabled := False;
      end;
    end;
  except
    on E: EHttpException do begin
      Application.CreateForm(TForm1, Form1);
      Form1.Label1.Caption := IniLangue.ReadString('MESSAGES', '19', 'Erreur');  
      Form1.BtnClose.Caption := IniLangue.ReadString('ID3TAG', 'BtnClose', 'Fermer');
      Form1.Memo.Lines.Add(IniLangue.ReadString('MESSAGES', '19', 'Erreur') + ' : ' + Cl.ReasonPhrase);
    end;
  end;
  Application.Run;
end.
