{
Copyright  Frdric MONTIN, 2008

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit Unit_Form_Egaliseur;

interface

uses
  Windows, Messages, Classes, Controls, Forms, Graphics,
  StdCtrls, ComCtrls, SysUtils, ExtCtrls, Menus, Dialogs;

type
  TFormEgaliseur = class(TForm)
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    ProgressBar5: TProgressBar;
    LabelClose: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    PopupMenuPreset: TPopupMenu;
    ProgressBar6: TProgressBar;
    ProgressBar7: TProgressBar;
    ProgressBar8: TProgressBar;
    ProgressBar9: TProgressBar;
    ProgressBar10: TProgressBar;
    MenuPresetRAZ: TMenuItem;
    MenuSavePreset: TMenuItem;
    N1: TMenuItem;
    MenuEditPreset: TMenuItem;
    MenuPresets: TMenuItem;
    MenuUserPresets: TMenuItem;
    procedure Label4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ProgressBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ProgressBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure LabelCloseClick(Sender: TObject);
    procedure LabelCloseMouseEnter(Sender: TObject);
    procedure LabelCloseMouseLeave(Sender: TObject);
    procedure MenuPresetEQClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoadUserPreset;
    procedure MenuSavePresetClick(Sender: TObject);
    procedure MenuEditPresetClick(Sender: TObject);
    procedure PopupMenuPresetPopup(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormEgaliseur: TFormEgaliseur;

implementation

uses Unit_Gestion_Langue, Bass, Unit1, Unit_Form_InfoBulle, DeKiBulleUtils;

{$R *.dfm}

//============================================================================//
{              remet les barres  0                                            }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.Label4Click(Sender: TObject);
begin
    MenuPresetEQClick(MenuPresetRAZ);
end;

//============================================================================//
{              lors de l'affichage de l'egaliseur                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.FormShow(Sender: TObject);
var
    i: integer;
begin
    Application.NormalizeAllTopMosts;

            { Gestion de la langue }
    GestionLangue(4);

            { Position des barres }
    for i := 0 to ComponentCount - 1 do
      if (Components[i] is TProgressBar) then
        (Components[i] as TProgressBar).position := Round(Form1.eq[(Components[i] as TProgressBar).Tag] * 10);

            { Couleurs }
    TransparentColorValue := FormInfoBulle.TransparentColorValue;
    TransparentColor      := FormInfoBulle.TransparentColor;
    Color                 := FormInfoBulle.Color;

    for i := 0 to ComponentCount - 1 do
      if (Components[i] is TProgressBar) then begin
        (Components[i] as TProgressBar).Brush.Color := Form1.ProgressBar1.Brush.Color;
        SendMessage((Components[i] as TProgressBar).Handle, WM_USER + 9, 0, Form1.ProgressBar1.Tag);
      end;

    Label1.Font.Color     := FormInfoBulle.Label1.Font.Color;
    LabelClose.Font.Color := Label1.Font.Color;
    Label4.Font.Color     := Label1.Font.Color;
    Label5.Font.Color     := Label1.Font.Color;
    Label6.Font.Color     := Label1.Font.Color;

            { Positions et dimensions }
    With FormInfoBulle.TextDistances do begin
        Label1.Left       := Left + 2;
        Label1.Top        := Top;
        for i := 0 to ComponentCount - 1 do
          if (Components[i] is TProgressBar) then begin
            (Components[i] as TProgressBar).Width := 14;
            (Components[i] as TProgressBar).Left := Left + ((Components[i] as TProgressBar).Width + 2) * ((Components[i] as TProgressBar).Tag - 1);
            (Components[i] as TProgressBar).Top := Top + 16;
          end;
        Label5.Left       := ProgressBar10.Left + ProgressBar10.Width + 2;
        Label5.Top        := Top + 16;
        Label4.Left       := Label5.Left;
        Label4.Top        := Top + 70;
        Label6.Left       := Label5.Left;
        Label6.Top        := Top + 124;
        LabelClose.Left   := Label5.Left - 6;
        LabelClose.Top    := Top;
        FormEgaliseur.Width  := Label6.Left + 24 + Right;
        FormEgaliseur.Height := Top  + 138 + Bottom;
    end;

            { On replace la form }
    if Form1.Left - Width > 0 then
        Left := Form1.Left - Width;
    Top  := Form1.Top + Form1.Height - Height;
    //if (Sender <> nil) then
    //    SetCursorPos(Left + Width div 2, Top + Height div 2);
end;

//============================================================================//
{              si on clique sur une des barres                                 }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.ProgressBar1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
    Gain  : Single;
    Barre : Integer;
begin
    With (Sender as TProgressBar) do begin
        Position := - Trunc(Y / Height * 301 - 150);
        Gain     := Position / 10;
        Barre    := Tag;
    end;
    Form1.eq[Barre] := Gain;
    SetEqualizer(False);
end;

procedure TFormEgaliseur.ProgressBar1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
    if ssLeft in Shift then
        ProgressBar1MouseDown(Sender, mbLeft, Shift, X, Y);
end;

//============================================================================//
{              fermeture de la fenetre                                         }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    Application.RestoreTopMosts;
    Action        := caFree;  // libre la mmoire
    FormEgaliseur := nil;
end;

procedure TFormEgaliseur.LabelCloseClick(Sender: TObject);
begin
    Close;
end;

//============================================================================//
{              dplacement de la form                                          }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
    if ssLeft in Shift then begin
        ReleaseCapture;
        Perform(WM_SYSCOMMAND, $F012, 0); // Dplace la form
    end;
end;

//============================================================================//
{              affichage de l'image du skin                                    }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.FormPaint(Sender: TObject);
var
    w,h     : integer;
    BmpFond : TBitmap;
begin
  if Assigned(FormInfoBulle.BmpFond) then begin
    w := FormInfoBulle.BmpFondDuplicateW;
    h := FormInfoBulle.BmpFondDuplicateH;
    BmpFond := FormInfoBulle.BmpFond;
    With Canvas do begin
        CopyRect(Rect(0, 0, w, h), BmpFond.Canvas, Rect(0, 0, w, h)); //HAUT GAUCHE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), 0, Width, h), BmpFond.Canvas, Rect(w + 1, 0, BmpFond.Width, h)); //HAUT DROITE
        CopyRect(Rect(w, 0, Width - (BmpFond.Width - w - 1), h), BmpFond.Canvas, Rect(w, 0, w + 1, h)); //HAUT MILIEU
        CopyRect(Rect(0, Height - (BmpFond.Height - h - 1), w, Height), BmpFond.Canvas, Rect(0, h + 1, w, BmpFond.Height)); //BAS GAUCHE
        CopyRect(Rect(0, h, w, Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(0, h, w, h + 1)); //MILIEU GAUCHE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), Height - (BmpFond.Height - h - 1), Width, Height), BmpFond.Canvas, Rect(w + 1, h + 1, BmpFond.Width, BmpFond.Height)); //BAS DROITE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), h, Width, Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(w + 1, h, BmpFond.Width, h + 1)); //MILIEU DROITE
        CopyRect(Rect(w, Height - (BmpFond.Height - h - 1), Width - (BmpFond.Width - w - 1), Height), BmpFond.Canvas, Rect(w, h + 1, w + 1, BmpFond.Height)); //BAS MILIEU
        CopyRect(Rect(w, h, Width - (BmpFond.Width - w - 1), Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(w, h, w + 1, h + 1)); //MILIEU
    end;
  end;
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.LabelCloseMouseEnter(Sender: TObject);
begin
    (Sender as TLabel).Font.Style := (Sender as TLabel).Font.Style + [fsUnderline];
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.LabelCloseMouseLeave(Sender: TObject);
begin
    (Sender as TLabel).Font.Style := (Sender as TLabel).Font.Style - [fsUnderline];
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.MenuPresetEQClick(Sender: TObject);
var
    Barre, i : Integer;
    t        : TStringList;
begin
    t := Split((Sender as TMenuItem).Hint, '$');
    for Barre := 1 to 10 do
        Form1.eq[Barre] := StrToIntDef(t[Barre], 0) / 100;
    t.Free;

            { Position des barres }
    for i := 0 to ComponentCount - 1 do
      if (Components[i] is TProgressBar) then
        (Components[i] as TProgressBar).position := Round(Form1.eq[(Components[i] as TProgressBar).Tag] * 10);

    SetEqualizer(False);
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.FormCreate(Sender: TObject);
var
  m : TMenuItem;
  l, t : TStringList;
  i : integer;
begin
  l := TStringList.Create;
  { Les preset sont inspirs de ceux du logiciel VLC }
  l.Add('Classical$0$0$0$0$0$0$-576$-576$-576$-768');
  l.Add('Club$0$0$640$448$448$448$256$0$0$0');
  l.Add('Dance$768$576$192$0$0$-448$-576$-576$0$0');
  l.Add('Fullbass$600$768$768$448$128$-320$-640$-832$-896$-896');
  l.Add('Fullbasstreble$576$448$0$-576$-384$128$640$896$960$960');
  l.Add('Fulltreble$-768$-768$-768$-320$192$896$1280$1280$1280$1344');
  l.Add('Headphones$384$896$448$-256$-192$128$384$768$1024$1152');
  l.Add('Largehall$832$832$448$448$0$-384$-384$-384$0$0');
  l.Add('Live$-384$0$320$448$448$448$320$192$192$192');
  l.Add('Party$576$576$0$0$0$0$0$0$576$576');
  l.Add('Pop$-128$384$576$640$448$0$-192$-192$-128$-128');
  l.Add('Reggae$0$0$0$-448$0$512$512$0$0$0');
  l.Add('Rock$640$384$-448$-640$-256$320$704$896$896$896');
  l.Add('Ska$-192$-384$-320$0$320$448$704$768$896$768');
  l.Add('Soft$384$128$0$-192$0$320$640$768$896$960');
  l.Add('Softrock$320$320$192$0$-320$-448$-256$0$192$704');
  l.Add('Techno$640$448$0$-448$-384$0$640$768$768$704');
  for i := 0 to l.Count - 1 do begin
    t := Split(l[i], '$');
    if (t.Count = 11) then begin
      m := TMenuItem.Create(Self);
      With m do begin
        Caption    := t[0];
        Hint       := l[i];
        OnClick    := MenuPresetEQClick;
      end;
      MenuPresets.Add(m);
    end;
    t.Free;
  end;
  l.Free;
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.LoadUserPreset;
var
  m : TMenuItem;
  l, t : TStringList;
  i : integer;
begin
  MenuEditPreset.Visible  := False;
  MenuUserPresets.Visible := False;
  if not(FileExists(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt')) then Exit;
  l := TStringList.Create;
  l.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt');
  l.Text := Trim(l.Text);
    // On supprime les anciens userpreset du menu
  MenuUserPresets.Clear;
    // On ajoute les userpreset au menu
  for i := 0 to l.Count - 1 do begin
    t := Split(l[i], '$');
    if (t.Count = 11) then begin
      m := TMenuItem.Create(Self);
      With m do begin
        Caption    := t[0];
        Hint       := l[i];
        OnClick    := MenuPresetEQClick;
      end;
      MenuUserPresets.Add(m);
    end;
    t.Free;
  end;
  MenuEditPreset.Visible  := l.Count > 0;
  MenuUserPresets.Visible := l.Count > 0;
  If l.Count = 0 then
    DeleteFile(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt');
  l.Free;
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.MenuSavePresetClick(Sender: TObject);
var
  PresetName, t : String;
  l : TStringList;
  Barre : integer;
begin
  PresetName:= InputBox('Name of the preset', 'Enter a name for the preset (ex: rock)', '');
  if (PresetName <> '') then begin
    l := TStringList.Create;
    if FileExists(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt') then
      l.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt');
    l.Text := Trim(l.Text);
    t := Trim(PresetName);
    for Barre := 1 to 10 do
      t := t + '$' + IntToStr(Round(Form1.eq[Barre] * 100));
    l.Add(t);
    l.SaveToFile(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt');
    l.Free;
  end;
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.MenuEditPresetClick(Sender: TObject);
begin
  if FileExists(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt') then
    Executer('notepad.exe', PChar(ExtractFilePath(ParamStr(0)) + 'eqpreset.txt'));
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TFormEgaliseur.PopupMenuPresetPopup(Sender: TObject);
begin
  LoadUserPreset;
end;

end.
