{
Copyright  Frdric MONTIN, 2008

dekibulle@free.fr
http://dekibulle.free.fr

**********************
*CeCILL-B (fr) NOTICE*
**********************

Ce logiciel est un programme informatique servant envoyer des informations
au site http://last.fm

Ce logiciel est rgi par la licence CeCILL-B soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-B telle que diffuse par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,   l'utilisation,   la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant 
donn sa spcificit de logiciel libre, qui peut le rendre complexe  
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invits  charger  et  tester  l'adquation  du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 l'utiliser et l'exploiter dans les mmes conditions de scurit. 

Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
pris connaissance de la licence CeCILL-B, et que vous en avez accept les
termes.
}

unit Scrobbler;

interface

uses
  Dialogs, Classes, SysUtils, SimpleTimer, HttpProt, IcsMD5, ICSUrl, Windows;

type
  TScrobbler = class
    private
      TimerScrobbler: TSimpleTimer;
      wArtiste, wTrack, wAlbum, wLength, wTime, wMbid : string;
      tsSubmissionURL, ts_stream_url : string;
      procedure TimerScrobblerTimer(Sender: TObject);
      function  GetHandShake : boolean;
      procedure AjoutLigneLog(Ligne : String);

    public
      LastFmUser, LastFmPassWord, ClientID, ClientVer : String;
      ProxyUser, ProxyPass, ProxyAddress, ProxyPort : String;
      tsSessionID : string;
      LastResponse  : String;
      EnableLogFile : Boolean;
      function  TempsGMT(H : TDateTime): TDateTime;
      constructor Create();
      function    SubmitScrob(sArtiste, sTrack, sAlbum, sLength, sTime, sMbid : string): Boolean;
      procedure   DemarrerScrob(sArtiste, sTrack, sAlbum, sMbid : String; sLength : Integer);
      procedure   ArreterScrob;
      function    GetPlayList: boolean;
      function    GetStreamName: string;
  end;

implementation

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
constructor TScrobbler.Create();
begin
  inherited;
  TimerScrobbler := TSimpleTimer.CreateEx(30000, TimerScrobblerTimer);
  tsSessionID    := '';
  LastResponse   := '';
  EnableLogFile  := True;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
function TScrobbler.GetHandShake: boolean;
var
    cl       : THttpCli;
    Data     : TMemoryStream;
    Response : TStringList;
begin
    AjoutLigneLog('[INFOS] Starting GetHandShake');
    Response         := TStringList.Create;
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    Result           := false;
    tsSessionID      := '';
    try
        if ProxyAddress <> '' then begin
            cl.ProxyUsername := ProxyUser;
            cl.ProxyPassword := ProxyPass;
            cl.Proxy         := ProxyAddress;
            cl.ProxyPort     := ProxyPort;
        end;
        cl.RcvdStream := Data;
        //ts := IntToStr(DateTimeToUnix(Now));
        //auth := MD5Print(MD5String(MD5Print5MD5String(LastFmPassWord)) + ts));
        //cl.URL := 'http://post.audioscrobbler.com/?hs=true&p=1.2&c=tst&v=1.0&u=' + User + '&t=' + ts + '&a=' + auth;
        cl.URL := 'http://post.audioscrobbler.com/?hs=true&p=1.1&c=' + ClientID + '&v=' + ClientVer + '&u=' + URLEncode(UTF8Encode(LastFmUser));
        try
            cl.Get;
            LastResponse  := Copy(StrPas(Data.Memory), 1, Data.Size);
            Response.Text := LastResponse;
            if Response.Strings[0] = 'UPTODATE' then begin
                Result          := True;                    //Le GetHandShake c'est bien pass
                tsSessionID     := Response.Strings[1];
                tsSubmissionURL := Response.Strings[2];
                //tsNowPlayingURL := Response.Strings[2];
            end;
        except
            on E: EHttpException do
                LastResponse := Cl.ReasonPhrase
            else
                raise;
        end;
    finally
        Data.Free;
        cl.Free;
        Response.Free;
    end;
    if Result then
        AjoutLigneLog('[INFOS] GetHandShake successfully! :o)')
    else
        AjoutLigneLog('[ERROR] GetHandShake error : ' + LastResponse);
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
function TScrobbler.SubmitScrob(sArtiste, sTrack, sAlbum, sLength, sTime, sMbid : string): Boolean;
var
    cl   : THttpCli;
    Data : TMemoryStream;
    v    : string;
    auth : string;
    i    : integer;
begin
  Result := False;
  for i := 1 to 2 do begin
    if (tsSessionID = '') and not GetHandShake then
        Exit;
    AjoutLigneLog(Format('[INFOS] Submitting the track : %s - %s', [sArtiste, sTrack]));
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    try
        if ProxyAddress <> '' then begin
            cl.ProxyUsername := ProxyUser;
            cl.ProxyPassword := ProxyPass;
            cl.Proxy         := ProxyAddress;
            cl.ProxyPort     := ProxyPort;
        end;
        cl.RcvdStream := Data;
        cl.URL := tsSubmissionURL;
        auth   := LowerCase(StrMD5(LowerCase(StrMD5(LastFmPassWord)) + tsSessionID));
        v      := 'u=' + URLEncode(LastFmUser) +  '&s=' + auth + '&a[0]=' + URLEncode(UTF8Encode(sArtiste)) + '&t[0]=' + URLEncode(UTF8Encode(sTrack)) +'&b[0]=' + URLEncode(UTF8Encode(sAlbum)) + '&m[0]=' + sMbid + '&l[0]=' + sLength + '&i[0]=' + sTime;
        cl.SendStream := TMemoryStream.Create;
        cl.SendStream.Write(v[1], Length(v));
        cl.SendStream.Seek(0, 0);
        try
            cl.Post;
            LastResponse := Copy(StrPas(Data.Memory), 1, Data.Size);
            Result       := Copy(LastResponse, 1, 2) = 'OK';
        except
            on E: EHttpException do
                LastResponse := Cl.ReasonPhrase
            else
                raise;
        end;
    finally
        Data.Free;
        cl.Free;
    end;
    if Result then begin
        AjoutLigneLog('[INFOS] Submission succeed! :o)');
        Break;
    end;
    AjoutLigneLog('[ERROR] Submitting error : ' + LastResponse);
    if i = 1 then
        AjoutLigneLog('[INFOS] Second try...');
    tsSessionID := '';
  end;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
procedure TScrobbler.DemarrerScrob(sArtiste, sTrack, sAlbum, sMbid : String; sLength : Integer);
begin
    ArreterScrob;
    if sLength <= 30 then
        Exit;
    wArtiste := sArtiste;
    wTrack   := sTrack;
    wAlbum   := sAlbum;
    wLength  := IntToStr(sLength);
    wTime    := FormatDateTime('yyyy-mm-dd hh:nn:ss', TempsGMT(Now));
    wMbid    := sMbid;
    if sLength < 480 then                // L'envoi se fera dans 50% de la dure de la chanson ou dans 240 secondes
        TimerScrobbler.Interval := Trunc(sLength / 2 * 1000)
    else
        TimerScrobbler.Interval := 240 * 1000;
    TimerScrobbler.Enabled := True;
    AjoutLigneLog(Format('[INFOS] Submitting in %d seconds : %s - %s', [Trunc(TimerScrobbler.Interval / 1000), wArtiste, wTrack]));
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
procedure TScrobbler.ArreterScrob;
begin
    if TimerScrobbler.Enabled then
        AjoutLigneLog('[INFOS] Stop waiting submission');
    TimerScrobbler.Enabled := False;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
procedure TScrobbler.TimerScrobblerTimer(Sender: TObject);
begin
    ArreterScrob;
    SubmitScrob(wArtiste, wTrack, wAlbum, wLength, wTime, wMbid);
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
procedure TScrobbler.AjoutLigneLog(Ligne : String);
var
    LogFileStrings : TStringList;
    LogFileName    : String;
begin
    if Not EnableLogFile then
        Exit;
    LogFileName := ExtractFilePath(ParamStr(0)) + 'deki-scrobbler.log';
    LogFileStrings := TStringList.Create;
    With LogFileStrings do begin
        if FileExists(LogFileName) then
            LoadFromFile(LogFileName);
        Ligne := FormatDateTime('dd-mm-yyyy hh:nn:ss', Now) + ' - ' + Ligne;
        Insert(0, Ligne);
        While Count > 100 do
            Delete(99);
        SaveToFile(LogFileName);
        Free;
    end;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
function TScrobbler.TempsGMT(H : TDateTime): TDateTime;
var
    Zone   : TTimeZoneInformation;
    Retour : Integer;
begin
    Retour := GetTimeZoneInformation(Zone);
        // DateHeure tant en heure locale => ajout des dcalages pour obtenir l'heure absolue
    Result := H;
    Case Retour Of
        TIME_ZONE_ID_UNKNOWN : Result := H + ( Zone.Bias                     / (24 * 60));
        TIME_ZONE_ID_STANDARD: Result := H + ((Zone.Bias + Zone.StandardBias)/ (24 * 60));
        TIME_ZONE_ID_DAYLIGHT: Result := H + ((Zone.Bias + Zone.DaylightBias)/ (24 * 60));
    End;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
{
procedure TScrobbler.NowPlaying(artiste, track, album : string);
var
    cl   : THttpCli;
    Data : TMemoryStream;
    Ini  : TIniFile;
    v    : string;
begin
    if (tsSessionID = '') and not GetHandShake then
        Exit;
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    try
        cl.RcvdStream := Data;
        cl.URL := tsNowPlayingURL;
        v := 's=' + tsSessionID + '&a=' + artiste + '&t=' + track + '&b=' + album + '&l&n&m';
        cl.SendStream := TMemoryStream.Create;
        cl.SendStream.Write(v[1], Length(v));
        cl.SendStream.Seek(0, 0);
        cl.Post;
        v := Copy(StrPas(Data.Memory), 1, Data.Size);
        ShowMessage(v);
    finally
        Data.Free;
        cl.Free;
    end;
end;
}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
function TScrobbler.GetPlayList: boolean;
var
    cl       : THttpCli;
    Data     : TMemoryStream;
    Response : TStringList;
begin
    AjoutLigneLog('[INFOS] Starting Get LastFm Stream URL');
    Response         := TStringList.Create;
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    Result           := false;
    try
        if ProxyAddress <> '' then begin
            cl.ProxyUsername := ProxyUser;
            cl.ProxyPassword := ProxyPass;
            cl.Proxy         := ProxyAddress;
            cl.ProxyPort     := ProxyPort;
        end;
        cl.RcvdStream := Data;
        cl.URL := 'http://ws.audioscrobbler.com/radio/handshake.php?username='+ URLEncode(UTF8Encode(LastFmUser)) + '&passwordmd5=' + LowerCase(IcsMD5.StrMD5(LastFmPassWord)) + '&player=' + ClientID;
        try
            cl.Get;
            LastResponse  := Copy(StrPas(Data.Memory), 1, Data.Size);
            Response.Text := LastResponse;
            if Response.Values['session'] <> 'FAILED' then begin
                Result       := True;                    //Le GetHandShake c'est bien pass
                tsSessionID  := Response.Values['session'];
                ts_stream_url:= Response.Values['stream_url'];
                AjoutLigneLog('[INFOS] GetPlayList successfull! :o) ' + tsSessionID);
                Response.Clear;
                Response.Add('#EXTM3U');
                Response.Add('#EXTINF:-1,Last.fm Stream Radio');
                Response.Add(ts_stream_url);
                Response.SaveToFile(ExtractFilePath(ParamStr(0)) + 'LastFmPlaylist.m3u');
            end;
        except
            on E: EHttpException do
                LastResponse := Cl.ReasonPhrase
            else
                raise;
        end;
    finally
        Data.Free;
        cl.Free;
        Response.Free;
    end;
    if not Result then
        AjoutLigneLog('[ERROR] GetPlayList error : ' + LastResponse);
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
function TScrobbler.GetStreamName: string;
var
    cl       : THttpCli;
    Data     : TMemoryStream;
    Response : TStringList;
begin
    Result := '';
    if tsSessionID = '' then
        Exit;
    Response         := TStringList.Create;
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    try
        if ProxyAddress <> '' then begin
            cl.ProxyUsername := ProxyUser;
            cl.ProxyPassword := ProxyPass;
            cl.Proxy         := ProxyAddress;
            cl.ProxyPort     := ProxyPort;
        end;
        cl.RcvdStream := Data;
        cl.URL := 'http://ws.audioscrobbler.com/radio/np.php?session=' + tsSessionID;
        try
            cl.Get;
            LastResponse  := Copy(StrPas(Data.Memory), 1, Data.Size);
            Response.Text := LastResponse;
            if Response.Values['track'] <> '' then begin
                Result := ' ' + Response.Values['artist'] + ' - ' + Response.Values['album'] + ' - ' + Response.Values['track'];
            end;
        except
            on E: EHttpException do
                LastResponse := Cl.ReasonPhrase
            else
                raise;
        end;
    finally
        Data.Free;
        cl.Free;
        Response.Free;
    end;
end;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////



end.
